/*
 Comparamos dos cadenas terminadas en 0 a ver si son iguales

*/
      .data
cad1: .asciz "¡Hola Mundo!"
cad2: .asciz "¡Hola Mundo!"
res:  .space 1

   .text
main:
   ldr r0, =cad1    @ r0: puntero a la primera cadena
   ldr r1, =cad2    @ r1: puntero a la segunda cadena

buc: 
   ldrb r2, [r0]    @ leemos un carácter de la primera cadena 
   cmp r2, #0       @ si es 0, hemos terminado 
   beq finc1

@ el carácter de la primera cadena no es a cero 

   ldrb r3, [r1]    @ leemos un carácter de la segunda cadena
   cmp r3,#0        @ si es cero, hemos terminado 
   beq dif          @ y las cadenas son diferentes 

@ quedan caracteres en ambas cadenas 

   cmp r2, r3       @ si son diferentes, hemos terminado 
   bne dif          @ y las cadenas son diferentes

@ los caracteres siguen siendo iguales,
@ seguimos con los siguientes caracteres de ambas cadenas

   add r0, r0, #1
   add r1, r1, #1
   b buc 

@ primera cadena finalizada

finc1:
   ldrb r3, [r1]    @ leemos un carácter de la segunda cadena 
   cmp r3, #0       @ si es 0, hemos terminado
   bne dif          @ y las dos cadenas son iguales 

gres:
   ldr r1, =res     @ almacenamos el resultado de la
   strb r2, [r1]    @ comparación
   wfi

@ las cadenas son diferentes

dif: 
   mov r2, #0xff    @ resultado para cadenas diferentes
   b gres 

@ las cadenas son iguales

igual:
   mov r2, #0       @ resultado para cadenas iguales
   b gres
   .end

