       .data
array: .byte 0b10000000,0b00000000 @ fila 0
       .byte 0b01000000,0b00000000 @ fila 1
       .byte 0b00100000,0b00000000 @ fila 2
       .byte 0b00001000,0b11111111 @ fila 3
@              ||||||||    ||||||||       
@ columnas:     01234567    89abcdef
@
      .balign 4
fil:  .word 2      @ fila entre 0 y 3
col:  .word 12     @ columna entre 0 y 15
val:  .byte 1      @ nuevo valor, 0 o 1

      .text
      
      @ Calculamos el índice del bit a modificar.
      @ Matriz serializada: index = (fila * 16) + columna

main: ldr r0,=fil
      ldr r0,[r0]    @ r0 = fila
      mov r1,#16
      mul r0,r0,r1   @ r0 = fila * 16
      ldr r1,=col
      ldr r1,[r1]    @ r1 = columna
      add r0,r1      @ r0 = índice del bit en la matriz serializada

      @ Calcula el byte que tiene el bit a modificar (b_mod)
      @ índice  = b_mod * 8 + offset
      @ (contando de izquierda a derecha)

      mov r1,r0        @ r1: índice
      lsr r0,#3        @ r0: cociente de dividir por ocho
      mov r2,#0b111    
      and r1,r2        @ r1: resto de la división

      ldr r2,=#0x80    @ máscara inicial para activar o desactivar     
      lsr r2,r1        @ desplaza la máscara al bit objetivo

      ldr r5,=array  
      ldrb r6,[r5,r0]  @ carga el byte objetivo (con el offset)
      ldr r7,=val
      ldr r7,[r7]
      cmp r7,#0        @ ¿activar o desactivar?
      beq set0      

set1: orr r6,r2       @ activamos usando la máscara
      b next

set0: mvn r2,r2
      and r6,r2       @ desactivamos usando la máscara inversa

next: strb r6,[r5,r0] @ sustituimos el byte original

      wfi
     .end
