
      .data
num1: .word  0x11223344
num2: .word  0x55667788   
res:  .space 8
      .equ   carry, 0x00010000

   .text
main:
   ldr   r0, =num1     @ cargamos los números
   ldr   r0, [r0]      @ a multiplicar en r0 y r1
   ldr   r1, =num2   
   ldr   r1, [r1]

   lsr   r5, r0, #16   @ mitad alta de num1 a r5
   lsr   r3, r1, #16   @ mitad alta de num1 a r3

   lsl   r6, r5, #16
   lsl   r7, r3, #16
   bic   r0, r0, r6    @ mitad baja de num1 queda en r0
   bic   r1, r1, r7    @ mitad baja de num2 queda en r1

   mov   r7, r1        @ r7: copia de la mitad baja de num1

/*

Aplicamos el algoritmo de multiplicación indicado, con 
(num 1 = {r5r0} y num2 = {r3r1} o {r3r7})

El resultado queda en {r3r0r7}

*/
   

   mul   r7, r0, r7   @ parcial r7xr0 
   mul   r0, r3, r0   @ parcial r3xr0
   mul   r1, r5, r1   @ parcial r5xr1
   mul   r3, r5, r3   @ parcial r3xr5

   add   r0, r1, r0   @ sumamos r5xr1 + r3xr0      
   bcc   saltar       @ vemos si tenemos que trasladar
                      @ un acarreo
   ldr   r6, =carry   @ y si es así, 
   add   r3, r3, r6   @ lo añadimos en el lugar correcto

saltar:   
   lsl   r4, r0, #16  @ colocamos en su sitio las
   lsr   r0, r0, #16  @ distintas partes (r3 - r0 - r7)
   add   r7, r7, r4   @ 32 bits menos significativos
   adc   r3, r3, r0   @ 32 bits más significativos

   ldr   r6, =res     @ dirección del resultado
   str   r7, [r6]     @ almacenamos los 32 bits menos sig.
   str   r3, [r6, #4] @ y los 32 bits más significativos

   wfi
   .end
