
      .data
num:  .word   0x07bbaacc      @ número de ejemplo
mant: .space  4               @ mantisa y signo
car:  .space  1               @ característica
      .equ signo, 0x80000000  @ signo negativo

   .text
main:
   ldr   r0,=num
   ldr   r0, [r0]     @ r0: número a normalizar
   mov   r1, #0       @ r1: para acumular el exponente
   mov   r2, #0       @ r2: signo (0 = positivo)
   cmp   r0, #0       @ comprobamos si el número es cero
   beq   nada         @ si lo es, hemos terminado
   bgt   bucle        @ comprobamos si es positivo

   ldr   r2, =signo   @ si es negativo, guardamos el signo
   neg   r0, r0       @ y normalizamos el valor absoluto

bucle:   
   lsl   r0, r0, #1   @ movemos los bits a la izquierda
   blt   final        @ salió un 1 por Z -> acabamos
   add   r1, r1, #1   @ incrementamos en 1 el exp. 
   b     bucle        @ y seguimos buscando

final:  
   lsr   r0, r0, #1   @ recuperamos el 1 perdido por Z
   orr   r0, r0, r2   @ ponemos el signo correcto
   mov   r2, #128  
   sub   r1, r2, r1   @ característica: -r1 + 128 

nada:   
   ldr   r3, =mant    @ almacenamos signo y mantisa
   str   r0, [r3]     @ y característica
   strb  r1, [r3, #4] @ (0's si originalmente num = 0)

   wfi
   .end
