
     .data
val: .byte  0xa7 @ dato de ejemplo
res: .space 2     @ resultado

   .text
main:
   mov   r2, #0x0f     @ enmascaramos todo menos el nibble 
   ldr   r0, =val      @ menos significativo 
   ldrb  r1, [r0]      @ cargamos el byte en r0
   and   r1, r1, r2
   cmp   r1, #0x09     @ vemos si '0' - '9' o 'A' - 'Z'
   bhi   mayor1

   add   r1, r1, #'0'  @ menor que 9 
   b     dig2

mayor1:   
   add   r1, r1, #0x37 @ mayor que 9 : 0x0A + 0x37 = 0x41 = 'A'

dig2:   
   ldr   r3, =res
   strb  r1, [r3, #1]  @ lo almacenamos en su sitio
@
@ hacemos lo mismo con el nibble (grupo de 4 bits)
@ más significativo.
@
   ldrb  r1, [r0]
   lsr   r1, r1, #4    @ eliminamos la parte ya convertida
   cmp   r1, #0x09
   bhi   mayor2

   add   r1, r1, #0x30
   b     fin

mayor2:   
   add   r1, r1, #0x37

fin:
   strb  r1, [r3]    @ lo almacenamos en su sitio

   wfi
   .end
